<!DOCTYPE html>
<!--[if lt IE 8 ]><html class="no-js ie ie7" lang="en"> <![endif]-->
<!--[if IE 8 ]><html class="no-js ie ie8" lang="en"> <![endif]-->
<!--[if IE 9 ]><html class="no-js ie ie9" lang="en"> <![endif]-->
<!--[if (gte IE 8)|!(IE)]><!--><html class="no-js" lang="de"> <!--<![endif]-->
<head>

   <!--- Basic Page Needs
   ================================================== -->
   <meta charset="utf-8">
	<title>{$user.sitetitle} - AustriaChat.net - Die &Ouml;sterreichische Chatcommunity</title>
	<meta name="description" content="" />
	<meta content="AustriaChat.net - Die &Ouml;sterreichische Chatcommunity" property="og:title" />  
	<meta name="keywords" content="oe3 ö3 chat sms.at uboot.com chatcommunity webchat austria oesterreich forum" />
	<meta name="author" content="AustriaChat.net" />
	<meta name="description" content="Die kostenlose und werbefreie ?sterreichische Chatcommunity. Endlich wieder Chatten wie im Uboot, sms.at, Orf Chat, usw. Wir sehen uns!" />
	<link href="https://austriachat.net/chat" rel="Chat"/>
	<link href="https://austriachat.net/forum" rel="Forum"/>
	<!-- mobile specific metas
   ================================================== -->
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1" />

   <!-- CSS
    ================================================== -->
   <link rel="stylesheet" href="{$themepath}/css/default.css" />
	<link rel="stylesheet" href="{$themepath}/css/layout.css" />  
	<link rel="stylesheet" href="{$themepath}/css/media-queries.css" /> 

   <!-- Script
   ================================================== -->
	<script src="js/modernizr.js"></script>

   <!-- Favicons
	================================================== -->
	<link rel="shortcut icon" href="favicon.png" />

</head>

<body>
<header id="top">
	<div class="row">
   		<div class="header-content twelve columns">
		      <h1 id="logo-text">{$user.sitetitle}</h1>
		</div>			
    </div>
</header> <!-- Header End -->
<div id="content-wrap">  
   <div class="row add-bottom">
		<div class="six columns add-bottom">
            <h3>&Uuml;ber {$user.username}</h3>
            <p><img class="pull-left" src="/forum/{$user.np_picture}" alt="Ist das {$user.username}?">
  			   {$user.fid2}</p><div id="gender"><img src="/npimages/{$user.gender}.png" /></div>
		</div>
		<div class="six columns add-bottom">
            <h3>&Uuml;ber mich:</h3>
            <p>Alter: {$user.age}<br />
			<ul>
			  <li><a href="//{$domain}/forum/private.php?action=send&uid={$user.fuid}">PN an {$user.username}</a></li>
			  <li>Forenposts: <a href="//{$domain}/forum/search.php?action=finduser&uid={$user.fuid}">{$forum.postnum}</a></li>
			  <li>{if $user.chatright!=""}{$user.username} ist ein <strong>{$user.chatright}</strong></li>{/if}
			  {if $user.room!=""}{$user.username} befindet sich im Raum {$user.room}{$user.roomlock}</li>{/if}
			  <li>Chatzeit: {$user.chattime}</li>
			{if $user.friendlink!=""}<li>{$user.friendlink}</li>{/if}
			</ul>
  			   </p>
			{if $user.favourits!=''}
			  <p>
				<h3>Meine Links</h3>
				<ul>
					{$user.favourits}
				</ul>
			  </p>
			{/if}
			</div>
	</div><!-- Row End-->
	{if $friends!=""}
	<div class="row section-head">
		<div class="twelve columns">

	         <h3>Freunde</h3>
	         {$friends}
         </div> 
	</div> <!-- Row End-->
	{/if}
	<hr>
<div class="row section-head">
{if $gb!=""}
	{$pagination}
{foreach from=$gb item=g}
<div class="twelve columns">
<a href="/np/{$g.username}">{$g.username}</a> schrieb am {$g.date}:
<p>{if $deltext==1}
<span style="float:right" style="font-size:xx-small;"><a href="/gb/del/{$guestbook.id}">[Eintrag l&ouml;schen]</a>
</span>
{/if}
{$g.text}<br /></p>
</div>
{/foreach}
<div class="twelve columns add-bottom">

            <h3 class="add-bottom">Pagination</h3>

            <nav class="pagination add-bottom">

				{$pagination}

		      </nav>

         </div>

{else}
	<div class="twelve columns">
		<p>Keine Eintr&auml;ge. Schreib doch einfach einen. ;-)</p>
	</div>
{/if}

  </div>
</div>
<footer>

      <div class="row"> 

      	<div class="twelve columns">	
				F&uuml;r den Inhalt ist ausschlie&szlig;lich der User selbst verantwortlich.<br />
 Diese Nickpage ist Teil der <a href="//www.austriachat.net" target="_blank">AustriaChat.net Community</a>.
      	</div>
	</div>
      <div id="go-top"><a class="smoothscroll" title="Back to Top" href="#top"><i class="fa fa-chevron-up"></i></a></div>

   </footer> <!-- End Footer-->


   <!-- Java Script
   ================================================== -->
   <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
   <script>window.jQuery || document.write('<script src="js/jquery-1.10.2.min.js"><\/script>')</script>
   <script type="text/javascript" src="js/jquery-migrate-1.2.1.min.js"></script>  
   <script src="js/main.js"></script>
	
</body>
</html>
